searchNodes=[{"doc":"Doctor is a utility which aims to provide insights into the health of your project's documentation. In addition to be a useful development time tool, Doctor can also be useful during CI/CD and can block merges and releases if the documentation coverage is not up to spec.Doctor comes with sane defaults out of the box, but if you wish to customize its settings, feel free to create your own .doctor.exs file.","ref":"Doctor.html","title":"Doctor","type":"module"},{"doc":"Provides the various CLI task entry points and CLI arg parsing.","ref":"Doctor.CLI.html","title":"Doctor.CLI","type":"module"},{"doc":"Given the CLI arguments, run the report on the project,","ref":"Doctor.CLI.html#generate_module_report_list/1","title":"Doctor.CLI.generate_module_report_list/1","type":"function"},{"doc":"Generate a report for a single project module.","ref":"Doctor.CLI.html#generate_single_module_report/2","title":"Doctor.CLI.generate_single_module_report/2","type":"function"},{"doc":"Given a list of individual module reports, process each item in the list with the configured reporter and return a pass or fail boolean","ref":"Doctor.CLI.html#process_module_report_list/2","title":"Doctor.CLI.process_module_report_list/2","type":"function"},{"doc":"This module defines a struct which houses all the configuration data for Doctor.","ref":"Doctor.Config.html","title":"Doctor.Config","type":"module"},{"doc":"Get the configuration defaults as a Config struct","ref":"Doctor.Config.html#config_defaults/0","title":"Doctor.Config.config_defaults/0","type":"function"},{"doc":"Get the configuration defaults as a string","ref":"Doctor.Config.html#config_defaults_as_string/0","title":"Doctor.Config.config_defaults_as_string/0","type":"function"},{"doc":"Get the configuration file name","ref":"Doctor.Config.html#config_file/0","title":"Doctor.Config.config_file/0","type":"function"},{"doc":"","ref":"Doctor.Config.html#t:t/0","title":"Doctor.Config.t/0","type":"type"},{"doc":"This module defines a struct which houses all the documentation data for module functions.","ref":"Doctor.Docs.html","title":"Doctor.Docs","type":"module"},{"doc":"Build the Docs struct from the results of Code.fetch_docs/0","ref":"Doctor.Docs.html#build/1","title":"Doctor.Docs.build/1","type":"function"},{"doc":"","ref":"Doctor.Docs.html#t:t/0","title":"Doctor.Docs.t/0","type":"type"},{"doc":"This module defines a struct which houses all the documentation data for an entire module.","ref":"Doctor.ModuleInformation.html","title":"Doctor.ModuleInformation","type":"module"},{"doc":"Breaks down the docs format entry returned from Code.fetch_docs(MODULE)","ref":"Doctor.ModuleInformation.html#build/2","title":"Doctor.ModuleInformation.build/2","type":"function"},{"doc":"Checks the provided module for a struct function which is injected into the module whenever you use defstruct","ref":"Doctor.ModuleInformation.html#contains_struct_type_spec?/1","title":"Doctor.ModuleInformation.contains_struct_type_spec?/1","type":"function"},{"doc":"Given the provided module, read the file from which the module was generated and convert the file to an AST.","ref":"Doctor.ModuleInformation.html#load_file_ast/1","title":"Doctor.ModuleInformation.load_file_ast/1","type":"function"},{"doc":"Given a ModuleInformation struct with the AST loaded, fetch all of the author defined functions","ref":"Doctor.ModuleInformation.html#load_user_defined_functions/1","title":"Doctor.ModuleInformation.load_user_defined_functions/1","type":"function"},{"doc":"","ref":"Doctor.ModuleInformation.html#t:t/0","title":"Doctor.ModuleInformation.t/0","type":"type"},{"doc":"This module exposes a struct which encapsulates all the results for a doctor report. Whether the module has a moduledoc, what the doc coverage is, the number of author defined functions, and so on.","ref":"Doctor.ModuleReport.html","title":"Doctor.ModuleReport","type":"module"},{"doc":"Given a ModuleInformation struct with the necessary fields completed, build the report.","ref":"Doctor.ModuleReport.html#build/1","title":"Doctor.ModuleReport.build/1","type":"function"},{"doc":"","ref":"Doctor.ModuleReport.html#t:t/0","title":"Doctor.ModuleReport.t/0","type":"type"},{"doc":"This module provides some utility functions for use in report generators.","ref":"Doctor.ReportUtils.html","title":"Doctor.ReportUtils","type":"module"},{"doc":"Calculate the overall doc coverage in the codebase","ref":"Doctor.ReportUtils.html#calc_overall_doc_coverage/1","title":"Doctor.ReportUtils.calc_overall_doc_coverage/1","type":"function"},{"doc":"Calculate the overall spec coverage in the codebase","ref":"Doctor.ReportUtils.html#calc_overall_spec_coverage/1","title":"Doctor.ReportUtils.calc_overall_spec_coverage/1","type":"function"},{"doc":"Given a list of module reports, count the total number of documented functions","ref":"Doctor.ReportUtils.html#count_total_documented_functions/1","title":"Doctor.ReportUtils.count_total_documented_functions/1","type":"function"},{"doc":"Given a list of module reports, count the total number of failed modules","ref":"Doctor.ReportUtils.html#count_total_failed_modules/2","title":"Doctor.ReportUtils.count_total_failed_modules/2","type":"function"},{"doc":"Given a list of module reports, count the total number of functions","ref":"Doctor.ReportUtils.html#count_total_functions/1","title":"Doctor.ReportUtils.count_total_functions/1","type":"function"},{"doc":"Given a list of module reports, count the total number of passed modules","ref":"Doctor.ReportUtils.html#count_total_passed_modules/2","title":"Doctor.ReportUtils.count_total_passed_modules/2","type":"function"},{"doc":"Given a list of module reports, count the total number of speced functions","ref":"Doctor.ReportUtils.html#count_total_speced_functions/1","title":"Doctor.ReportUtils.count_total_speced_functions/1","type":"function"},{"doc":"Check whether Doctor overall has passed or failed validation","ref":"Doctor.ReportUtils.html#doctor_report_passed?/2","title":"Doctor.ReportUtils.doctor_report_passed?/2","type":"function"},{"doc":"Checks whether the provided module passed validation","ref":"Doctor.ReportUtils.html#module_passed_validation?/2","title":"Doctor.ReportUtils.module_passed_validation?/2","type":"function"},{"doc":"Defines the behaviour for a reporter","ref":"Doctor.Reporter.html","title":"Doctor.Reporter","type":"behaviour"},{"doc":"","ref":"Doctor.Reporter.html#c:generate_report/2","title":"Doctor.Reporter.generate_report/2","type":"callback"},{"doc":"","ref":"Doctor.Reporter.html#t:module_reports/0","title":"Doctor.Reporter.module_reports/0","type":"type"},{"doc":"This reporter generates a full documentation coverage report and lists all the files in the project along with whether they pass or fail.","ref":"Doctor.Reporters.Full.html","title":"Doctor.Reporters.Full","type":"module"},{"doc":"Generate a full Doctor report and print to STDOUT","ref":"Doctor.Reporters.Full.html#generate_report/2","title":"Doctor.Reporters.Full.generate_report/2","type":"function"},{"doc":"This module produces a report for a single project module. This is useful when you need to figure out exactly why a particular module failed validation. The only validations that are taken into account during this report are single module validations. In other words, the only thing that is checked are things that pertain to a single module like:min_module_doc_coveragemin_module_spec_coveragemoduledoc_requiredexception_moduledoc_requiredstruct_type_spec_required","ref":"Doctor.Reporters.ModuleExplain.html","title":"Doctor.Reporters.ModuleExplain","type":"module"},{"doc":"Generate the output for a single module report","ref":"Doctor.Reporters.ModuleExplain.html#generate_report/2","title":"Doctor.Reporters.ModuleExplain.generate_report/2","type":"function"},{"doc":"This module provides convenience functions for use when generating reports","ref":"Doctor.Reporters.OutputUtils.html","title":"Doctor.Reporters.OutputUtils","type":"module"},{"doc":"Generate a string with a configure amount of width and padding","ref":"Doctor.Reporters.OutputUtils.html#gen_fixed_width_string/3","title":"Doctor.Reporters.OutputUtils.gen_fixed_width_string/3","type":"function"},{"doc":"Generate a line in a table with the given width and padding. Expects a list with either a 2 or 3 element tuple.","ref":"Doctor.Reporters.OutputUtils.html#generate_table_line/1","title":"Doctor.Reporters.OutputUtils.generate_table_line/1","type":"function"},{"doc":"Prints a divider of a given length","ref":"Doctor.Reporters.OutputUtils.html#print_divider/1","title":"Doctor.Reporters.OutputUtils.print_divider/1","type":"function"},{"doc":"Prints a string in red","ref":"Doctor.Reporters.OutputUtils.html#print_error/1","title":"Doctor.Reporters.OutputUtils.print_error/1","type":"function"},{"doc":"Prints a checkmark of an X if true of false is provided respectively","ref":"Doctor.Reporters.OutputUtils.html#print_pass_or_fail/1","title":"Doctor.Reporters.OutputUtils.print_pass_or_fail/1","type":"function"},{"doc":"Prints a string in green","ref":"Doctor.Reporters.OutputUtils.html#print_success/1","title":"Doctor.Reporters.OutputUtils.print_success/1","type":"function"},{"doc":"This reporter generates a full documentation coverage report and lists all the files in the project along with whether they pass or fail.","ref":"Doctor.Reporters.Short.html","title":"Doctor.Reporters.Short","type":"module"},{"doc":"Generate a short Doctor report and print to STDOUT","ref":"Doctor.Reporters.Short.html#generate_report/2","title":"Doctor.Reporters.Short.generate_report/2","type":"function"},{"doc":"This reporter generates a short summary documentation coverage report and lists overall how many modules passed/failed.","ref":"Doctor.Reporters.Summary.html","title":"Doctor.Reporters.Summary","type":"module"},{"doc":"Generate a short summary Doctor report and print to STDOUT","ref":"Doctor.Reporters.Summary.html#generate_report/2","title":"Doctor.Reporters.Summary.generate_report/2","type":"function"},{"doc":"This module defines a struct which houses all the documentation data for function specs.","ref":"Doctor.Specs.html","title":"Doctor.Specs","type":"module"},{"doc":"Build a spec definition for each result from Code.Typespec.fetch_specs/1","ref":"Doctor.Specs.html#build/1","title":"Doctor.Specs.build/1","type":"function"},{"doc":"","ref":"Doctor.Specs.html#t:t/0","title":"Doctor.Specs.t/0","type":"type"},{"doc":"Doctor is a command line utility that can be used to ensure that your project documentation remains healthy. For more in depth documentation on Doctor or to file bug/feature requests, please check out https://github.com/akoutmos/doctor.The mix doctor command supports the following CLI flags (all of these options and more are also configurable from your .doctor.exs file). The following CLI flags are supported:--config_file Provide a relative or absolute path to a `.doctor.exs` file to use during the execution of the mix command. --full When generating a Doctor report of your project, use the Doctor.Reporters.Full reporter. --short When generating a Doctor report of your project, use the Doctor.Reporters.Short reporter. --summary When generating a Doctor report of your project, use the Doctor.Reporters.Summary reporter. --raise If any of your modules fails Doctor validation, then raise an error and return a non-zero exit status. --failed If set only the failed modules will be reported. Works with --full and --short options. --umbrella By default, in an umbrella project, each app will be evaluated independently against the specified thresholds in your .doctor.exs file. This flag changes that behavior by aggregating the results of all your umbrella apps, and then comparing those results to the configured thresholds.","ref":"Mix.Tasks.Doctor.html","title":"Mix.Tasks.Doctor","type":"task"},{"doc":"Figuring out why a particular module failed Doctor validation can sometimes be a bit difficult when the relevant information is embedded within a table with other validation results.The mix doctor.explain command has only a single required argument. That argument is the name of the module that you wish to get a detailed report of. For example you could run the following from the terminal:$ mix doctor.explain MyApp.Some.ModuleTo generate a report like this:Doctor file found. Loading configuration. Function @doc @spec ------------------------------- generate_report/2 ✗ ✗ Module Results: Doc Coverage: 0.0% --&gt; Your config has a &#39;min_module_doc_coverage&#39; value of 80 Spec Coverage: 0.0% Has Module Doc: ✓ Has Struct Spec: N/AIn addition, the following CLI flags are supported (similarly to the mix doctor command):--config-file Provide a relative or absolute path to a `.doctor.exs` file to use during the execution of the mix command. --raise If any of your modules fails Doctor validation, then raise an error and return a non-zero exit status.To use these command line args you would do something like so:$ mix doctor.explain --raise --config_file /some/path/to/some/.doctor.exs MyApp.Some.ModuleNote that mix doctor.explain takes a module name instead of a file path since you can define multiple modules in a single file.","ref":"Mix.Tasks.Doctor.Explain.html","title":"Mix.Tasks.Doctor.Explain","type":"task"},{"doc":"Doctor is a command line utility that can be used to ensure that your project documentation remains healthy. For more in depth documentation on Doctor or to file bug/feature requests, please check out https://github.com/akoutmos/doctor.The mix doctor.gen.config command can be used to create a .doctor.exs file with the default Doctor settings. The default file contents are:%Doctor.Config{ ignore_modules: [], ignore_paths: [], min_module_doc_coverage: 40, min_module_spec_coverage: 0, min_overall_doc_coverage: 50, min_overall_spec_coverage: 0, moduledoc_required: true, exception_moduledoc_required: true, raise: false, reporter: Doctor.Reporters.Full, struct_type_spec_required: true, umbrella: false }","ref":"Mix.Tasks.Doctor.Gen.Config.html","title":"Mix.Tasks.Doctor.Gen.Config","type":"task"},{"doc":"This Mix task generates a .doctor.exs configuration file","ref":"Mix.Tasks.Doctor.Gen.Config.html#run/1","title":"Mix.Tasks.Doctor.Gen.Config.run/1","type":"function"},{"doc":"Doctor Ensure that your documentation is healthy with Doctor! This library contains a mix task that you can run against your project to generate a documentation coverage report. Items which are reported on include: the presence of module docs, which functions do/don't have docs, which functions do/don't have typespecs, and if your struct modules provide typespecs. You can generate a .doctor.exs config file to specify what thresholds are acceptable for your project. If documentation coverage drops below your specified thresholds, the mix doctor task will return a non zero exit status.The primary motivation with this tool is to have something simple which can be hooked up into CI to ensure that project documentation standards are respected and upheld. This is particular useful in a team environment when you want to maintain a minimum threshold for documentation coverage.","ref":"readme.html","title":"Doctor","type":"extras"},{"doc":"Adding :doctor to your list of dependencies in mix.exs:def deps do [ {:doctor, &quot;~&gt; 0.19.0&quot;, only: :dev} ] endDocumentation can be found at https://hexdocs.pm/doctor.","ref":"readme.html#installation","title":"Doctor - Installation","type":"extras"},{"doc":"There are a few tools in the Elixir ecosystem that overlap slightly in functionality with Doctor. It is useful for you to know how Doctor differs from these tools and some use cases that Doctor serves.CredoCredo is a phenomenal library that can be used to perform a wide range of static analysis checks against your codebase. It can check for lingering IO.inspect() statements, it can check for unsafe atom conversions, and it can also check that the cyclomatic complexity of control statements is within a particular range to name a few.The one area where Doctor and Credo do overlap is that with either tool you have the capability to enforce that @moduledoc attributes are present in modules. Given that this is the only overlap between the two tools, I generally use both in my projects and perform both validations during CI/CD.InchInch is another great tool written by René Föhring that is specifically catered to analyzing a project's documentation (very much like Doctor). Inch will scan your project's source files and check for the presence of function documentation and report back to you what grade it thinks your project has earned.Inch does not appear to support checking for function typespecs, returning non-zero status codes when validation fails, tuning thresholds via a configuration file, or checking for struct module typespecs. On the other hand, these were things that were important to me personally and so I wrote Doctor to fill that void. In a team context, I find Doctor to be invaluable in ensuring that a project maintains a certain level of documentation by failing CI/CD if certain thresholds have not been met.If I have misrepresented any of the aforementioned libraries...feel free to open up an issue :).","ref":"readme.html#comparison-with-other-tools","title":"Doctor - Comparison with other tools","type":"extras"},{"doc":"Doctor comes with 2 mix tasks. One to run the documentation coverage report, and another to generate a .doctor.exs config file.To run the doctor mix task and generate a report, run: mix doctor. To generate a .doctor.exs config file with defaults, run: mix doctor.gen.config. To get help documentation, run mix help doctor and mix help doctor.gen.config. The outputs of those help menus can be seen here:Running mix help doctor yields: mix doctor Doctor is a command line utility that can be used to ensure that your project documentation remains healthy. For more in depth documentation on Doctor or to file bug/feature requests, please check out https://github.com/akoutmos/doctor. The mix doctor command supports the following CLI flags (all of these options and more are also configurable from your .doctor.exs file). The following CLI flags are supported: --full When generating a Doctor report of your project, use the Doctor.Reporters.Full reporter. --short When generating a Doctor report of your project, use the Doctor.Reporters.Short reporter. --summary When generating a Doctor report of your project, use the Doctor.Reporters.Summary reporter. --raise If any of your modules fails Doctor validation, then raise an error and return a non-zero exit status. --failed If set only the failed modules will be reported. Works with --full and --short options. --umbrella By default, in an umbrella project, each app will be evaluated independently against the specified thresholds in your .doctor.exs file. This flag changes that behavior by aggregating the results of all your umbrella apps, and then comparing those results to the configured thresholds.Running mix help doctor.gen.config yields: mix doctor.gen.config Doctor is a command line utility that can be used to ensure that your project documentation remains healthy. For more in depth documentation on Doctor or to file bug/feature requests, please check out https://github.com/akoutmos/doctor. The mix doctor.gen.config command can be used to create a .doctor.exs file with the default Doctor settings. The default file contents are: %Doctor.Config{ ignore_modules: [], ignore_paths: [], min_module_doc_coverage: 40, min_module_spec_coverage: 0, min_overall_doc_coverage: 50, min_overall_spec_coverage: 0, moduledoc_required: true, exception_moduledoc_required: true, raise: false, reporter: Doctor.Reporters.Full, struct_type_spec_required: true, umbrella: false }","ref":"readme.html#usage","title":"Doctor - Usage","type":"extras"},{"doc":"Below is a sample .doctor.exs file with some sample values for the various fields:%Doctor.Config{ ignore_modules: [], ignore_paths: [], min_module_doc_coverage: 40, min_module_spec_coverage: 0, min_overall_doc_coverage: 50, min_overall_spec_coverage: 0, moduledoc_required: true, exception_moduledoc_required: true, raise: false, reporter: Doctor.Reporters.Full, struct_type_spec_required: true, umbrella: false }For the reporter field, the following reporters included with Doctor:Doctor.Reporters.FullDoctor.Reporters.ShortDoctor.Reporters.Summary","ref":"readme.html#configuration","title":"Doctor - Configuration","type":"extras"},{"doc":"Report created for Doctor itself:$ mix doctor Doctor file found. Loading configuration. --------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Doc Cov Spec Cov Module File Functions No Docs No Specs Module Doc Struct Spec 100% 0% Doctor.CLI lib/cli/cli.ex 2 0 2 Yes N/A 100% 0% Doctor.Config lib/config.ex 3 0 3 Yes Yes 100% 0% Doctor.Docs lib/docs.ex 1 0 1 Yes Yes N/A N/A Doctor lib/doctor.ex 0 0 0 Yes N/A 100% 100% Mix.Tasks.Doctor lib/mix/tasks/doctor.ex 1 0 0 Yes N/A 100% 0% Mix.Tasks.Doctor.Gen.Config lib/mix/tasks/doctor.gen.config.ex 1 0 1 Yes N/A 100% 0% Doctor.ModuleInformation lib/module_information.ex 4 0 4 Yes Yes 100% 0% Doctor.ModuleReport lib/module_report.ex 1 0 1 Yes Yes 100% 0% Doctor.ReportUtils lib/report_utils.ex 9 0 9 Yes N/A N/A N/A Doctor.Reporter lib/reporter.ex 0 0 0 Yes N/A 100% 0% Doctor.Reporters.Full lib/reporters/full.ex 1 0 1 Yes N/A 100% 0% Doctor.Reporters.OutputUtils lib/reporters/output_utils.ex 1 0 1 Yes N/A 100% 0% Doctor.Reporters.Short lib/reporters/short.ex 1 0 1 Yes N/A 100% 0% Doctor.Reporters.Summary lib/reporters/summary.ex 1 0 1 Yes N/A 100% 0% Doctor.Specs lib/specs.ex 1 0 1 Yes Yes --------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Summary: Passed Modules: 15 Failed Modules: 0 Total Doc Coverage: 100.0% Total Spec Coverage: 3.7% Doctor validation has passed!Report created for Phoenix:$ mix doctor Doctor file not found. Using defaults. -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Doc Cov Spec Cov Module File Functions No Docs No Specs Module Doc 100% 0% Mix.Phoenix lib/mix/phoenix.ex 18 0 18 YES 0% 0% Mix.Phoenix.Context lib/mix/phoenix/context.ex 6 6 6 YES 63% 0% Mix.Phoenix.Schema lib/mix/phoenix/schema.ex 8 3 8 YES 100% 0% Mix.Tasks.Compile.Phoenix lib/mix/tasks/compile.phoenix.ex 2 0 2 YES 100% 0% Mix.Tasks.Phx.Digest.Clean lib/mix/tasks/phx.digest.clean.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Digest lib/mix/tasks/phx.digest.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx lib/mix/tasks/phx.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Gen.Cert lib/mix/tasks/phx.gen.cert.ex 2 0 2 YES 100% 0% Mix.Tasks.Phx.Gen.Channel lib/mix/tasks/phx.gen.channel.ex 1 0 1 YES 86% 14% Mix.Tasks.Phx.Gen.Context lib/mix/tasks/phx.gen.context.ex 7 1 6 YES 100% 17% Mix.Tasks.Phx.Gen.Embedded lib/mix/tasks/phx.gen.embedded.ex 6 0 5 YES 100% 0% Mix.Tasks.Phx.Gen.Html lib/mix/tasks/phx.gen.html.ex 4 0 4 YES 100% 0% Mix.Tasks.Phx.Gen.Json lib/mix/tasks/phx.gen.json.ex 4 0 4 YES 100% 0% Mix.Tasks.Phx.Gen.Presence lib/mix/tasks/phx.gen.presence.ex 1 0 1 YES 100% 14% Mix.Tasks.Phx.Gen.Schema lib/mix/tasks/phx.gen.schema.ex 7 0 6 YES 100% 0% Mix.Tasks.Phx.Gen.Secret lib/mix/tasks/phx.gen.secret.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Routes lib/mix/tasks/phx.routes.ex 1 0 1 YES 100% 0% Mix.Tasks.Phx.Server lib/mix/tasks/phx.server.ex 1 0 1 YES 100% 0% Phoenix lib/phoenix.ex 3 0 3 YES 100% 17% Phoenix.Channel lib/phoenix/channel.ex 12 0 10 YES 100% 18% Phoenix.Channel.Server lib/phoenix/channel/server.ex 17 0 14 YES 100% 0% Phoenix.CodeReloader lib/phoenix/code_reloader.ex 2 0 2 YES 40% 0% Phoenix.CodeReloader.Proxy lib/phoenix/code_reloader/proxy.ex 5 3 5 YES 33% 0% Phoenix.CodeReloader.Server lib/phoenix/code_reloader/server.ex 6 4 6 YES 88% 25% Phoenix.Config lib/phoenix/config.ex 8 1 6 YES 100% 52% Phoenix.Controller lib/phoenix/controller.ex 42 0 20 YES 100% 0% Phoenix.Controller.Pipeline lib/phoenix/controller/pipeline.ex 6 0 6 YES 100% 100% Phoenix.Digester lib/phoenix/digester.ex 2 0 0 YES 100% 0% Phoenix.Endpoint lib/phoenix/endpoint.ex 25 0 25 YES 100% 0% Phoenix.Endpoint.Cowboy2Adapter lib/phoenix/endpoint/cowboy2_adapter.ex 3 0 3 YES 0% 0% Phoenix.Endpoint.Cowboy2Handler lib/phoenix/endpoint/cowboy2_handler.ex 5 5 5 YES 100% 0% Phoenix.Endpoint.CowboyAdapter lib/phoenix/endpoint/cowboy_adapter.ex 2 0 2 YES 0% 0% Phoenix.Endpoint.CowboyWebSocket lib/phoenix/endpoint/cowboy_websocket.ex 8 8 8 YES 100% 0% Phoenix.Endpoint.RenderErrors lib/phoenix/endpoint/render_errors.ex 3 0 3 YES 93% 0% Phoenix.Endpoint.Supervisor lib/phoenix/endpoint/supervisor.ex 15 1 15 YES 0% 0% Phoenix.Endpoint.Watcher lib/phoenix/endpoint/watcher.ex 2 2 2 YES NA NA Plug.Exception.Phoenix.ActionClauseErro lib/phoenix/exceptions.ex 0 0 0 NO NA NA Phoenix.NotAcceptableError lib/phoenix/exceptions.ex 0 0 0 YES 100% 0% Phoenix.MissingParamError lib/phoenix/exceptions.ex 1 0 1 YES 0% 0% Phoenix.ActionClauseError lib/phoenix/exceptions.ex 2 2 2 NO 60% 0% Phoenix.Logger lib/phoenix/logger.ex 5 2 5 YES 83% 100% Phoenix.Naming lib/phoenix/naming.ex 6 1 0 YES NA NA Phoenix.Param.Map lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Integer lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.BitString lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Atom lib/phoenix/param.ex 0 0 0 NO NA NA Phoenix.Param.Any lib/phoenix/param.ex 0 0 0 NO 0% 0% Phoenix.Param lib/phoenix/param.ex 1 1 1 YES 100% 0% Phoenix.Presence lib/phoenix/presence.ex 17 0 17 YES NA NA Phoenix.Router.NoRouteError lib/phoenix/router.ex 0 0 0 YES 100% 0% Phoenix.Router lib/phoenix/router.ex 11 0 11 YES 100% 0% Phoenix.Router.ConsoleFormatter lib/phoenix/router/console_formatter.ex 1 0 1 YES 95% 0% Phoenix.Router.Helpers lib/phoenix/router/helpers.ex 20 1 20 YES 100% 0% Phoenix.Router.Resource lib/phoenix/router/resource.ex 1 0 1 YES 100% 20% Phoenix.Router.Route lib/phoenix/router/route.ex 5 0 4 YES 100% 0% Phoenix.Router.Scope lib/phoenix/router/scope.ex 9 0 9 YES NA NA Phoenix.Socket.InvalidMessageError lib/phoenix/socket.ex 0 0 0 YES 57% 0% Phoenix.Socket lib/phoenix/socket.ex 14 6 14 YES NA NA Phoenix.Socket.Reply lib/phoenix/socket/message.ex 0 0 0 YES 100% 0% Phoenix.Socket.Message lib/phoenix/socket/message.ex 1 0 1 YES NA NA Phoenix.Socket.Broadcast lib/phoenix/socket/message.ex 0 0 0 YES 50% 0% Phoenix.Socket.PoolSupervisor lib/phoenix/socket/pool_supervisor.ex 4 2 4 YES NA NA Phoenix.Socket.Serializer lib/phoenix/socket/serializer.ex 0 0 0 YES 0% 0% Phoenix.Socket.V1.JSONSerializer lib/phoenix/socket/serializers/v1_json_serializer.ex 3 3 3 YES 0% 0% Phoenix.Socket.V2.JSONSerializer lib/phoenix/socket/serializers/v2_json_serializer.ex 3 3 3 YES 100% 0% Phoenix.Socket.Transport lib/phoenix/socket/transport.ex 6 0 6 YES NA NA Phoenix.Template.UndefinedError lib/phoenix/template.ex 0 0 0 YES 100% 45% Phoenix.Template lib/phoenix/template.ex 11 0 6 YES 0% 0% Phoenix.Template.EExEngine lib/phoenix/template/eex_engine.ex 1 1 1 YES NA NA Phoenix.Template.Engine lib/phoenix/template/engine.ex 0 0 0 YES 0% 0% Phoenix.Template.ExsEngine lib/phoenix/template/exs_engine.ex 1 1 1 YES NA NA Phoenix.ChannelTest.NoopSerializer lib/phoenix/test/channel_test.ex 0 0 0 YES 100% 11% Phoenix.ChannelTest lib/phoenix/test/channel_test.ex 19 0 17 YES 100% 94% Phoenix.ConnTest lib/phoenix/test/conn_test.ex 17 0 1 YES 100% 0% Phoenix.Token lib/phoenix/token.ex 2 0 2 YES 67% 0% Phoenix.Transports.LongPoll lib/phoenix/transports/long_poll.ex 3 1 3 YES 50% 0% Phoenix.Transports.LongPoll.Server lib/phoenix/transports/long_poll_server.ex 4 2 4 YES 0% 0% Phoenix.Transports.WebSocket lib/phoenix/transports/websocket.ex 2 2 2 YES 100% 0% Phoenix.View lib/phoenix/view.ex 9 0 9 YES -------------------------------------------------------------------------------------------------------------------------------------------------------------------------- Summary: Passed Modules: 72 Failed Modules: 7 Total Doc Coverage: 85.1% Total Spec Coverage: 15.3% Doctor validation has passed!","ref":"readme.html#sample-reports","title":"Doctor - Sample reports","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"Fixedmix doctor.explain now works in umbrella projectsProperly measure documentation coverage in nested modulesProperly measure documentation with __using__Fix @moduledoc detection for older elixir versions","ref":"changelog.html#0-19-0-2022-7-19","title":"Changelog - [0.19.0] - 2022-7-19","type":"extras"},{"doc":"@doc false assumes no explicit spec and does not count against resultsSupport for using macro (thanks to @pnezis)No reporting of missing docs for exception modules (thanks to @pnezis)","ref":"changelog.html#0-18-0-2021-5-27","title":"Changelog - [0.18.0] - 2021-5-27","type":"extras"},{"doc":"Bumped up the Elixir version due to use of Mix.Task.recursing/0","ref":"changelog.html#0-17-0-2021-1-11","title":"Changelog - [0.17.0] - 2021-1-11","type":"extras"},{"doc":"Fixed spec coverage bugAdded ability to filter modules using Regex","ref":"changelog.html#0-16-0-2020-12-27","title":"Changelog - [0.16.0] - 2020-12-27","type":"extras"},{"doc":"AddedAdded mix doctor.explain command so that it is easier to debug why a particular module is failing validationFixedModules with behaviours that are aliased were not being counted properly","ref":"changelog.html#0-15-0-2020-6-23","title":"Changelog - [0.15.0] - 2020-6-23","type":"extras"},{"doc":"AddedAdditional configuration option struct_type_spec_required that checks for struct module type specs","ref":"changelog.html#0-14-0-2020-3-19","title":"Changelog - [0.14.0] - 2020-3-19","type":"extras"},{"doc":"FixedFixed spec coverage for behavior callbacks","ref":"changelog.html#0-13-0-2020-5-20","title":"Changelog - [0.13.0] - 2020-5-20","type":"extras"},{"doc":"AddedAbility to aggregate umbrella results into one reportAbility to pass custom path to config fileCLI docs via mix help doctor and mix help doctor.gen.config","ref":"changelog.html#0-12-0-2020-3-19","title":"Changelog - [0.12.0] - 2020-3-19","type":"extras"},{"doc":"AddedAbility to pass in a file name as a string for ignore_paths","ref":"changelog.html#0-11-0-2020-1-29","title":"Changelog - [0.11.0] - 2020-1-29","type":"extras"},{"doc":"AddedAbility to raise from Mix when an error is encountered","ref":"changelog.html#0-10-0-2019-11-20","title":"Changelog - [0.10.0] - 2019-11-20","type":"extras"},{"doc":"Fixed.doctor.exs file not found at root of umbrella project","ref":"changelog.html#0-9-0-2019-11-11","title":"Changelog - [0.9.0] - 2019-11-11","type":"extras"},{"doc":"FixedFixed Decimal math when module contains no doc coverage","ref":"changelog.html#0-8-0-2019-6-20","title":"Changelog - [0.8.0] - 2019-6-20","type":"extras"},{"doc":"AddedTravis CI and testsFixedIncorrect reporting on failed modules","ref":"changelog.html#0-7-0-2019-6-10","title":"Changelog - [0.7.0] - 2019-6-10","type":"extras"},{"doc":"AddedShort reporterFixedIncorrect spec coverage","ref":"changelog.html#0-6-0-2019-6-5","title":"Changelog - [0.6.0] - 2019-6-5","type":"extras"},{"doc":"ChangedFixed counting issue when there are multiple modules in a single fileChanged reporters around to be more DRY and share report calculation functionalityAdded tests for Doctor reporting functionality","ref":"changelog.html#0-5-0-2019-6-2","title":"Changelog - [0.5.0] - 2019-6-2","type":"extras"},{"doc":"ChangedLoaded application vs starting the application to avoid Ecto errors connecting to DB during Doctor validation","ref":"changelog.html#0-4-0-2019-1-23","title":"Changelog - [0.4.0] - 2019-1-23","type":"extras"},{"doc":"ChangedUpdated dependencies and fixed depreciation warning","ref":"changelog.html#0-3-0-2018-11-30","title":"Changelog - [0.3.0] - 2018-11-30","type":"extras"},{"doc":"FixedUmbrella project exit status code","ref":"changelog.html#0-2-0-2018-11-30","title":"Changelog - [0.2.0] - 2018-11-30","type":"extras"},{"doc":"AddedInitial release of Doctor.","ref":"changelog.html#0-1-0-2018-10-04","title":"Changelog - [0.1.0] - 2018-10-04","type":"extras"}]